Sponsored Content
Full Discussion: Do while loop in a do while
Top Forums Shell Programming and Scripting Do while loop in a do while Post 302574171 by nitin on Wednesday 16th of November 2011 05:29:12 PM
Old 11-16-2011
Do while loop in a do while

Hi,
I've a script that is using do while loop. It reads some some stuf using ps command then calls a function. The function has another do while loop in it.
My problem is that when the second loop is completed, the script exits. The whole thing is a bit complex, I'll post some snippet here. Any suggestions will be appreciated like always.

Code:
TELNET_QUIT=/tmp/telnet_quit.tmp  # file for telnet sessions.  Suppress on screen display
TELNET_LOG=/tmp/telnet_`date +%Y-%m-%d`.tmp
TELNET_TEST=NULL
echo "QUIT">$TELNET_QUIT

function telnetTest {
 	echo "  Please wait. "
	while read -r -u3 LINE1; read -r -u4 LINE2;
		do
		telnet  $LINE1 $LINE2 <$TELNET_QUIT >$TELNET_LOG 2>&1
		wait $!
		TELNET_TEST=$(grep "Connection closed by foreign host." $TELNET_LOG | wc -l)
		if (($TELNET_TEST)); then
		   echo "  OK. $LINE2" >>/tmp/somelog
		else
		   echo "  Problem! $LINE2" >>/tmp/somelog
		fi
		sleep 4
		more $TELNET_LOG >>/tmp/somelog
	done 3< "$TMPFILE" 4< "$TMPFILE2"  # Works till here, then exits out completely 
} # End of function

function getmyInfo  {
# We get my_SERVERS_NUM value from some where… snip 
my_SERVERS_NUM=1  # hard coding for one only
my_SERVER=10.10.10.10
TMPFILE=/tmp/tmp1.out
echo 10.10.10.10>$TMPFILE
my_SERVER_PORT=9120
TMPFILE2=/tmp/tmp2.out
echo 9120 >$TMPFILE2

if [ $my_SERVERS_NUM -ge 2 ]; then
	echo "  Many servers to check. " 
	telnetTest
else
	echo "  Only one server to check. "
	telnetTest
fi
}  # End of function

ps -ef |  awk '/[m]yAgent/{print $8}' | while read lines ;
	do
    		set -- $lines
		my_PATH=`echo $lines | sed '$s/myAgent.bin$//'`
		echo -n "  Analyze this instance (y/n)? " 
		read answer</dev/tty
		if [ "$answer" = y ]  ; then	
		my_pid=`ps -ef | grep $line | grep -v grep | awk '{print $2}'`
		getmyInfo
		fi
	done

#some cleanup stuff
#EOF

Thanks for looking.

Nitin
 

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Is there a better way I could have run this loop. (For loop with two variables)

Sorry for such a dreadful title, but I'm not sure how to be more descriptive. I'm hoping some of the more gurutastic out there can take a look at a solution I came up with to a problem, and advice if there are better ways to have gone about it. To make a long story short around 20K pieces of... (2 Replies)
Discussion started by: DeCoTwc
2 Replies

2. Shell Programming and Scripting

Using variables created sequentially in a loop while still inside of the loop [bash]

I'm trying to understand if it's possible to create a set of variables that are numbered based on another variable (using eval) in a loop, and then call on it before the loop ends. As an example I've written a script called question (The fist command is to show what is the contents of the... (2 Replies)
Discussion started by: DeCoTwc
2 Replies

3. Shell Programming and Scripting

Null Handling in Until loop. . .loop won't stop

Hi Im running this script, which is supposed to find the max value build some tables and then stop running once all the tables are built. Thing is , it keeps assigning a null value to $h and then $g is null so it keep building tables i.e. testupdateNUL. How can I stop this? Here is what I have: ... (4 Replies)
Discussion started by: brandono66
4 Replies

4. Shell Programming and Scripting

BASH loop inside a loop question

Hi all Sorry for the basic question, but i am writing a shell script to get around a slightly flaky binary that ships with one of our servers. This particular utility randomly generates the correct information and could work first time or may work on the 12th or 100th attempt etc !.... (4 Replies)
Discussion started by: rethink
4 Replies

5. Shell Programming and Scripting

S# in a for loop - concatenate $(loop counter)

Hi, hope I am posting in the right section. My problem is that I have 2 or more arguments passed and I want to check if the arguments passed exists or not. The first argument should not exist and the remaining others should exist. example: ./shells.sh argument1 argument2 argument3 ... (5 Replies)
Discussion started by: fight4love
5 Replies

6. Shell Programming and Scripting

My for loop decides to become an infinite loop?

Hi, I was debating if I should put this in the dummies or scripts section, I apologize in advance if I chose poorly. Fairly new to Unix and BASH scripting but I thought I made it fairly well given my limited understanding. However, the output indicates that it's looping and I'm ending up with a... (5 Replies)
Discussion started by: gotreef
5 Replies

7. Shell Programming and Scripting

Array Variable being Assigned Values in Loop, But Gone when Loop Completes???

Hello All, Maybe I'm Missing something here but I have NOOO idea what the heck is going on with this....? I have a Variable that contains a PATTERN of what I'm considering "Illegal Characters". So what I'm doing is looping through a string containing some of these "Illegal Characters". Now... (5 Replies)
Discussion started by: mrm5102
5 Replies

8. Shell Programming and Scripting

Reset while loop to loop same file multiple times

Hi, I want to read file multiple times. Right now i am using while loop but that is not working. ex. While read line do while read line2 do echo stmt1 #processing some data based on data., done < file2.txt done < file1.txt # This will have 10... (4 Replies)
Discussion started by: tmalik79
4 Replies

9. Shell Programming and Scripting

awk loop using array:wish to store array values from loop for use outside loop

Here's my code: awk -F '' 'NR==FNR { if (/time/ && $5>10) A=$2" "$3":"$4":"($5-01) else if (/time/ && $5<01) A=$2" "$3":"$4-01":"(59-$5) else if (/time/ && $5<=10) A=$2" "$3":"$4":0"($5-01) else if (/close/) { B=0 n1=n2; ... (2 Replies)
Discussion started by: klane
2 Replies

10. Shell Programming and Scripting

For loop or while loop from a text file

Hi all, i developed a script to measure the uptime of a process in a Solaris 10/11 environments. All is well, but i came across a situation where there are multiple processes of the same name. Basically i have the following result file: beVWARS 13357 19592122 beVWARS 14329 19591910... (4 Replies)
Discussion started by: nms
4 Replies
MKTEMP(1)						    BSD General Commands Manual 						 MKTEMP(1)

NAME
mktemp -- make temporary file name (unique) SYNOPSIS
mktemp [-d] [-q] [-u] template DESCRIPTION
The mktemp utility takes the given file name template and overwrites a portion of it to create a file name. This file name is unique and suitable for use by the application. The template may be any file name with at least 6 of 'Xs' appended to it, for example /tmp/temp.XXXXXX. The trailing 'Xs' are replaced with the current process number and/or a unique letter combination. The number of unique file names mktemp can return depends on the number of 'Xs' provided; six 'Xs' will result in mktemp testing roughly 26 ** 6 combinations. If mktemp can successfully generate a unique file name, the file is created with mode 0600 (unless the -u flag is given) and the filename is printed to standard output. OPTIONS
The available options are as follows: -d Make a directory instead of a file. -q Fail silently if an error occurs. This is useful if a script does not want error output to go to standard error. -u Operate in ``unsafe'' mode. The temp file will be unlinked before mktemp exits. This is slightly better than mktemp(3) but still introduces a race condition. Use of this option is not encouraged. RETURN VALUES
The mktemp utility exits with a value of 0 on success, and 1 on failure. EXAMPLES
The following sh(1) fragment illustrates a simple use of mktemp where the script should quit if it cannot get a safe temporary file. TMPFILE=`mktemp /tmp/$0.XXXXXX` || exit 1 echo "program output" >> $TMPFILE In this case, we want the script to catch the error itself. TMPFILE=`mktemp -q /tmp/$0.XXXXXX` if [ $? -ne 0 ]; then echo "$0: Can't create temp file, exiting..." exit 1 fi Note that one can also check to see that $TMPFILE is zero length instead of checking $?. This would allow the check to be done later one in the script (since $? would get clobbered by the next shell command). SEE ALSO
mkstemp(3), mktemp(3) HISTORY
The mktemp utility appeared in OpenBSD. BSD
November, 20, 1996 BSD
All times are GMT -4. The time now is 04:14 PM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy